#include <stdio.h>
#include "util.h"
#include "vpack.h"
#include "globals.h"
#include "cluster.h"
#include "output_clustering.h"
#include "path_length.h"
#define OMEGA  0.20
extern char* model;
struct fault_sim *FSIM;
int sNumEdges = 0;
extern char* gSensFile;
float AverageCrit =0.0 ;
//float sFactor = 0.0;
int read_fault_sim()
{
    char lFileName[1024];
    char src[1024];
    char sink[1024];
    float lcrit;
    int lSrcBlkId, lSinkBlkId;
    FILE *fp;
    float totalCrit =0.0;
    int i,j,lItem;
    FSIM = (struct fault_sim*) my_malloc(num_blocks*sizeof(struct fault_sim));
    for(i=0;i<num_blocks;i++)
    {
        for(j=0;j<NUM_BLK;j++)
        {
            FSIM[i].blkId[j] = -1;
            FSIM[i].crit[j] = 0.0;
        }
        FSIM[i].lCnt = 0;
    }
    printf(" Reading the crit FILE %s \n",gSensFile);
    fp = fopen(gSensFile,"r+");
    if(fp == NULL)
    {
        printf(" FILE %s cannot be opened. Try generating a new file using the criticality generator.\n",gSensFile);
        exit(0);
    }
    while(!feof(fp))
    {
        fscanf(fp,"%s --> %s = %f\n", src, sink, &lcrit);
        totalCrit += lcrit;
        lSrcBlkId = get_blk_id(src);
        lSinkBlkId =  get_blk_id(sink);
        if(FSIM[lSrcBlkId].lCnt > NUM_BLK)
        {
            printf(" COUNT OF BLK ID %s gone above limit \n",src);
            exit(0);
        }
        lItem = FSIM[lSrcBlkId].lCnt;
        FSIM[lSrcBlkId].blkId[lItem] = lSinkBlkId;
        FSIM[lSrcBlkId].crit[lItem] = lcrit;
        FSIM[lSrcBlkId].lCnt++;
        sNumEdges++;
    }

  //  printf(" THE sNumEdges is %d\n",sNumEdges);
   //BETTR RESULT WITH 1000 constant optimization.
    if(sNumEdges < 1000) sNumEdges = 1000;

    sFactor = (((float)(sNumEdges)/1000)) * (float)OMEGA;
     sFactor = 0.6; //beta value to be used 
   AverageCrit = totalCrit/sNumEdges; 
   printf(" Average Crit = %f \n", AverageCrit);
    return 1;
}

int get_blk_id(char *xName)
{
    int i;
    for(i=0;i<num_blocks;i++)
    {
        if(!strcmp(xName, block[i].name))
        {
            return i;
        }
    }
    printf(" BLOCK ID for node %s not found \n",xName);
}

float get_crit_gain( int from, int to)
{
    // BUG FIXED it should be from to -- > from ; from is the block looking for candidates. so others are input.
    int max ;
    int i;
    max = FSIM[to].lCnt;
    for(i=0;i<max;i++)
    {
        if(FSIM[to].blkId[i] == from)
        {
            //found blk ;
            return (FSIM[to].crit[i]);
        }
    }
    max = FSIM[from].lCnt;
    for(i=0;i<max;i++)
    {
        if(FSIM[from].blkId[i] == to)
        {
            //found blk ;
            return (FSIM[from].crit[i]);
        }
    }
    //    printf("CRIT NOT DEFINED FOR BLK ID %s and %s \n", block[from].name, 
    //          block[to].name);
    return 0.0;
}

float get_crit_gain_clust(int to)
{
    // BUG FIXED it should be from to -- > from ; from is the block looking for candidates. so others are input.
    int max ;
    int i;
    int lC;
    int from;
    float lCrit = 0.0;
    int lFound =0;
    for(lC =0; lC < gClustCnt; lC++)
    {
        from = gClustBlk[lC];
        if(from == NO_CLUSTER)
            break;
        max = FSIM[to].lCnt;
        for(i=0;i<max;i++)
        {
            if(FSIM[to].blkId[i] == from)
            {
                //found blk ;
                lCrit +=FSIM[to].crit[i];
                lFound++;
                break;
            }
        }
	//IT SHOULD NOT COME HERE !!!! 
        max = FSIM[from].lCnt;
        for(i=0;i<max;i++)
        {
            if(FSIM[from].blkId[i] == to)
            {
                //found blk ;
                lCrit += FSIM[from].crit[i];
                lFound++;
                break;
            }
        }
    }
    if(lFound)
        lCrit = lCrit/AverageCrit;
    return (lCrit);
}

float get_blk_crit(int xBlk)
{
    int ipin;
    int iblk,k;
    float lCrit = 0.0;
    float lgain;
    int netId;
    int lFound =1;
    for(k=0;k< block[xBlk].num_nets;k++)
    {
        netId = block[xBlk].nets[k];
        for(ipin=0;ipin<net[netId].num_pins;ipin++)
        {
            iblk = net[netId].pins[ipin];
            lCrit += get_crit_gain(iblk, xBlk);
            lFound++;
        }
    }
    return (lCrit/lFound);
}

float get_total_crit()
{
    // BUG FIXED it should be from to -- > from ; from is the block looking fo
    int max ;
    int i;
    int blk;
    int k;
    float lCrit = 0.0;
    int lFound =0;
    int lCount =0;
    for(i=0;i<num_blocks;i++)
    {
        max = FSIM[i].lCnt;
        for(k=0;k<max;k++)
        {
            lCount++;
            if(FSIM[i].crit[k] >0)
	    {
	//	printf(" %s -> %s %f \n",block[i].name,block[FSIM[i].blkId[k]].name, FSIM[i].crit[k]);
	
		lFound++;
	    }
            lCrit += FSIM[i].crit[k];
        }
    }
    printf(" THE TOTAL FOUND IS %f  among < %d , %d>\n",lCrit,lFound, lCount);
    return lCrit;
}

void reset_crit_gain( int from, int to)
{
    // BUG FIXED it should be from to -- > from ; from is the block looking fo
    int max ;
    int i;
    max = FSIM[to].lCnt;
    for(i=0;i<max;i++)
    {
        if(FSIM[to].blkId[i] == from)
        {
            //found blk ;
            FSIM[to].crit[i] = 0.0;
        }
    }
    max = FSIM[from].lCnt;
    for(i=0;i<max;i++)
    {
        if(FSIM[from].blkId[i] == to)
        {
            //found blk ;
            FSIM[from].crit[i]=0.0;
        }
    }
    //    printf("CRIT NOT DEFINED FOR BLK ID %s and %s \n", block[from].name,
    //          block[to].name);
}

void recompute_crit(int **cluster_contents,int *cluster_occupancy,
        int cluster_size, int inputs_per_cluster, int num_clusters,
        int lut_size)
{
    int icluster;
    int iblk;
    int lNumBlk;
    int j;
    FILE *fp;
    int from, to;
    int k;
    char file[1024];
    sprintf(file,"%s.cluster",model);
    fp = fopen(file,"w+");

    for (icluster=0;icluster<num_clusters;icluster++) {
        lNumBlk = cluster_occupancy[icluster];
	fprintf(fp," %d ",icluster);
        for (iblk=0;iblk<lNumBlk;iblk++) {
            from = cluster_contents[icluster][iblk];
	    fprintf(fp," %s ",block[from].name);
            for(j=iblk+1;j<lNumBlk;j++)
            {
                to = cluster_contents[icluster][j];
                reset_crit_gain(from,to);
	    }

	}
	for(k=lNumBlk; k<cluster_size;k++)
		fprintf(fp," NAL ");

	fprintf(fp,"\n");
    } 
    fclose(fp);
}

void rewrite_crit_file(int **cluster_contents)
{
    char filename[1024];
    FILE *fp ;
    FILE *lIdMap ;
    char src[1024], sink[1024];
    float lcrit;
    int lSrcBlkId, lSinkBlkId,lSrcClustId, lSinkClustId;
    int lClustBlk1, lClustBlk2;
    sprintf(filename,"%s.crit",model);
    fp = fopen(filename,"w+");

    lIdMap = fopen(gSensFile,"r+");
    if((fp == NULL) || (lIdMap == NULL))
    {
        printf(" FILE %s cannot be opened. Try faultsim again\n",filename);
        exit(0);
    }
    while(!feof(lIdMap))
    {
        fscanf(lIdMap,"%s --> %s = %f\n", src, sink, &lcrit);
        lSrcBlkId = get_blk_id(src);
        lSinkBlkId =  get_blk_id(sink);
        lSrcClustId = get_cluster_of_block(lSrcBlkId);
        lSinkClustId = get_cluster_of_block(lSinkBlkId);
        if(lSrcClustId == lSinkClustId) continue;
        lClustBlk1 = cluster_contents[lSrcClustId][0];
        lClustBlk2 = cluster_contents[lSinkClustId][0];

        fprintf(fp,"%s --> %s = %f\n",block[lClustBlk1].name,
                block[lClustBlk2].name,lcrit);

    }
    fclose(fp);
    fclose(lIdMap);
}

